aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorEryu Guan <eguan@redhat.com>2016-09-07 17:57:15 +0800
committerEryu Guan <eguan@redhat.com>2016-09-08 15:02:14 +0800
commit0cc271642a41e04c621dbb681960022736e56fe2 (patch)
tree4c69b18028433b1b07fa484917cfd6c963334cfe
parentd67700c75a0af8e926fc5bf5111217454a217c3a (diff)
downloadxfstests-dev-0cc271642a41e04c621dbb681960022736e56fe2.tar.gz
generic: simple permission check on hard links
Overlayfs had a bug that hardlinks don't share inode, if chmod/chown/etc. is performed on one of the links then the inode belonging to the other one won't be updated. The following patch fixed this issue: 51f7e52 ovl: share inode for hard link This is a simple test that has nothing overlayfs specific, so make it a generic test. Reviewed-by: Dave Chinner <dchinner@redhat.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rwxr-xr-xtests/generic/37873
-rw-r--r--tests/generic/378.out3
-rw-r--r--tests/generic/group1
3 files changed, 77 insertions, 0 deletions
diff --git a/tests/generic/378 b/tests/generic/378
new file mode 100755
index 0000000000..8139b4d5d0
--- /dev/null
+++ b/tests/generic/378
@@ -0,0 +1,73 @@
+#! /bin/bash
+# FS QA Test 378
+#
+# Simple permission check on hard links.
+#
+# Overlayfs had a bug that hardlinks don't share inode, if chmod/chown/etc.
+# is performed on one of the links then the inode belonging to the other
+# one won't be updated. The following patch fixed this issue
+#
+# 51f7e52 ovl: share inode for hard link
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os IRIX Linux
+_require_test
+_require_user
+
+# Setup testfile and its hardlink
+testfile=$TEST_DIR/testfile.$seq
+testlink=$testfile.hardlink
+rm -f $testfile $testlink
+echo "You should not see this" >$testfile
+ln $testfile $testlink
+
+# remove read permission from testfile and unprivileged user should have no
+# permission to read testfile and hardlink
+chmod -r $testfile
+_user_do "cat $testfile"
+_user_do "cat $testlink"
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/378.out b/tests/generic/378.out
new file mode 100644
index 0000000000..f1af0e56e8
--- /dev/null
+++ b/tests/generic/378.out
@@ -0,0 +1,3 @@
+QA output created by 378
+Permission denied
+Permission denied
diff --git a/tests/generic/group b/tests/generic/group
index 2b2ee8bf24..a602b01655 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -380,3 +380,4 @@
375 auto quick acl
376 auto quick metadata
377 attr auto quick metadata
+378 auto quick metadata